package techreborn.blocks;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumBlockRenderType;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import reborncore.common.util.ItemNBTHelper;
import reborncore.shields.RebornCoreShields;
import techreborn.client.TechRebornCreativeTab;

/**
 * Created by mark on 14/05/16.
 */
public class BlockDistributor extends Block {

    AxisAlignedBB AABB = new AxisAlignedBB(0.0625D, 0.0D, 0.0625D, 0.9375D, 0.0625D, 0.9375D);

    public BlockDistributor( ) {
        super(Material.field_151573_f);
        func_149711_c(2f);
        func_149663_c("techreborn.distributor");
    }

    public static ItemStack getReleaseStack(){
        ItemStack newStack = new ItemStack(Items.field_185159_cQ);
        ItemNBTHelper.setString(newStack, "type", "btm");
        ItemNBTHelper.setBoolean(newStack, "vanilla", false);
        return newStack;
    }

    @Override
    public AxisAlignedBB func_180646_a(IBlockState blockState, World worldIn, BlockPos pos) {
        return field_185506_k;
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        return AABB;
    }

    public boolean func_149662_c(IBlockState state)
    {
        return false;
    }

    public boolean func_149686_d(IBlockState state)
    {
        return false;
    }

    public boolean func_176205_b(IBlockAccess worldIn, BlockPos pos)
    {
        return true;
    }

    @Override
    public void func_180634_a(World worldIn, BlockPos pos, IBlockState state, Entity entityIn) {
        if(!entityIn.field_70170_p.field_72995_K){
            if(entityIn instanceof EntityPlayer){
                EntityPlayer player = (EntityPlayer) entityIn;
                if(player.func_184592_cb() != null && player.func_184592_cb().func_77973_b() == Items.field_185159_cQ){
                    if(ItemNBTHelper.getString(player.func_184592_cb(), "type", "null").equals("btm")){
                        return;
                    }
                }
                player.func_184201_a(EntityEquipmentSlot.OFFHAND, getReleaseStack());
            }
        }
    }

    @Override
    public EnumBlockRenderType func_149645_b(IBlockState state) {
        return EnumBlockRenderType.INVISIBLE;
    }
}
