package techreborn.blocks;

import me.modmuss50.jsonDestroyer.api.ITexturedBlock;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyInteger;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import reborncore.common.BaseBlock;
import techreborn.client.TechRebornCreativeTab;
import techreborn.init.ModBlocks;

import java.security.InvalidParameterException;
import java.util.List;

public class BlockMachineFrame extends BaseBlock implements ITexturedBlock
{
	public static final String[] types = new String[] { "machine", "advancedMachine", "highlyAdvancedMachine" };
	public PropertyInteger METADATA;

	public BlockMachineFrame(Material material)
	{
		super(material);
		func_149663_c("techreborn.machineFrame");
		func_149647_a(TechRebornCreativeTab.instance);
		func_149711_c(1f);
		this.func_180632_j(this.func_176223_P().func_177226_a(METADATA, 0));
	}

	public static ItemStack getFrameByName(String name, int count)
	{
		for (int i = 0; i < types.length; i++)
		{
			if (types[i].equalsIgnoreCase(name))
			{
				return new ItemStack(ModBlocks.machineframe, count, i);
			}
		}
		throw new InvalidParameterException("The part " + name + " could not be found.");
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void func_149666_a(Item item, CreativeTabs creativeTabs, List list)
	{
		for (int meta = 0; meta < types.length; meta++)
		{
			list.add(new ItemStack(item, 1, meta));
		}
	}

	@Override
	public int func_180651_a(IBlockState state)
	{
		int meta = func_176201_c(state);
		return meta;
	}

	@Override
	public String getTextureNameFromState(IBlockState blockState, EnumFacing facing)
	{
		return "techreborn:blocks/machine/machine_blocks/" + types[func_176201_c(blockState)] + "_machine_block";
	}

	@Override
	public int amountOfStates()
	{
		return types.length;
	}

	@Override
	public int func_176201_c(IBlockState state)
	{
		return state.func_177229_b(METADATA);
	}

	protected BlockStateContainer func_180661_e()
	{

		METADATA = PropertyInteger.func_177719_a("type", 0, types.length - 1);
		return new BlockStateContainer(this, METADATA);
	}

	@Override
	public IBlockState func_176203_a(int meta)
	{
		return this.func_176223_P().func_177226_a(METADATA, meta);
	}
}
