package techreborn.client.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IContainerListener;
import reborncore.client.gui.BaseSlot;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import reborncore.client.gui.SlotOutput;
import reborncore.common.container.RebornContainer;
import techreborn.tiles.TileMatterFabricator;

public class ContainerMatterFabricator extends RebornContainer
{

	public int progressTime;
	EntityPlayer player;
	TileMatterFabricator tile;

	public ContainerMatterFabricator(TileMatterFabricator tileMatterfab, EntityPlayer player)
	{
		tile = tileMatterfab;
		this.player = player;

		// input
		this.func_75146_a(new BaseSlot(tileMatterfab.inventory, 0, 33, 17));
		this.func_75146_a(new BaseSlot(tileMatterfab.inventory, 1, 33, 35));
		this.func_75146_a(new BaseSlot(tileMatterfab.inventory, 2, 33, 53));
		this.func_75146_a(new BaseSlot(tileMatterfab.inventory, 3, 51, 17));
		this.func_75146_a(new BaseSlot(tileMatterfab.inventory, 4, 51, 35));
		this.func_75146_a(new BaseSlot(tileMatterfab.inventory, 5, 51, 53));

		// outputs
		this.func_75146_a(new SlotOutput(tileMatterfab.inventory, 6, 116, 35));

		int i;

		for (i = 0; i < 3; ++i)
		{
			for (int j = 0; j < 9; ++j)
			{
				this.func_75146_a(new BaseSlot(player.field_71071_by, j + i * 9 + 9, 8 + j * 18, 84 + i * 18));
			}
		}

		for (i = 0; i < 9; ++i)
		{
			this.func_75146_a(new BaseSlot(player.field_71071_by, i, 8 + i * 18, 142));
		}
	}

	@Override
	public boolean func_75145_c(EntityPlayer p_75145_1_)
	{
		return true;
	}

	@Override
	public void func_75142_b()
	{
		super.func_75142_b();
		for (int i = 0; i < this.field_75149_d.size(); i++)
		{
			IContainerListener IContainerListener = this.field_75149_d.get(i);
			if (this.progressTime != tile.progresstime)
			{
				IContainerListener.func_71112_a(this, 0, tile.progresstime);
			}
		}
	}

	@Override
	public void func_75132_a(IContainerListener crafting)
	{
		super.func_75132_a(crafting);
		crafting.func_71112_a(this, 0, tile.progresstime);
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void func_75137_b(int id, int value)
	{
		if (id == 0)
		{
			this.progressTime = value;
		}
	}

	public int getProgressScaled(int scale)
	{
		if (progressTime != 0)
		{
			return progressTime * scale / tile.maxProgresstime();
		}
		return 0;
	}

}
