package techreborn.client.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IContainerListener;
import net.minecraft.inventory.IInventory;
import reborncore.client.gui.BaseSlot;
import net.minecraft.item.ItemStack;
import reborncore.client.gui.SlotOutput;
import reborncore.common.container.RebornContainer;
import techreborn.api.RollingMachineRecipe;
import techreborn.tiles.TileRollingMachine;

public class ContainerRollingMachine extends RebornContainer
{

	EntityPlayer player;
	TileRollingMachine tile;
	int currentItemBurnTime;
	int burnTime;
	int energy;

	public ContainerRollingMachine(TileRollingMachine tileRollingmachine, EntityPlayer player)
	{
		tile = tileRollingmachine;
		this.player = player;

		for (int l = 0; l < 3; l++)
		{
			for (int k1 = 0; k1 < 3; k1++)
			{
				this.func_75146_a(
						new BaseSlot(tileRollingmachine.craftMatrix, k1 + l * 3, 30 + k1 * 18, 17 + l * 18));
			}
		}

		// output
		this.func_75146_a(new SlotOutput(tileRollingmachine.inventory, 0, 124, 35));
		// battery
		this.func_75146_a(new BaseSlot(tileRollingmachine.inventory, 2, 8, 51));

		int i;

		for (i = 0; i < 3; ++i)
		{
			for (int j = 0; j < 9; ++j)
			{
				this.func_75146_a(new BaseSlot(player.field_71071_by, j + i * 9 + 9, 8 + j * 18, 84 + i * 18));
			}
		}

		for (i = 0; i < 9; ++i)
		{
			this.func_75146_a(new BaseSlot(player.field_71071_by, i, 8 + i * 18, 142));
		}
	}

	@Override
	public boolean func_75145_c(EntityPlayer player)
	{
		return true;
	}

	@Override
	public final void func_75130_a(IInventory inv)
	{
		ItemStack output = RollingMachineRecipe.instance.findMatchingRecipe(tile.craftMatrix, tile.func_145831_w());
		tile.inventory.func_70299_a(1, output);
	}

	@Override
	public void func_75132_a(IContainerListener crafting)
	{
		super.func_75132_a(crafting);
		crafting.func_71112_a(this, 0, tile.runTime);
		crafting.func_71112_a(this, 1, tile.tickTime);
		crafting.func_71112_a(this, 2, (int) tile.getEnergy());
	}

	@Override
	public void func_75142_b()
	{
		for (int i = 0; i < this.field_75149_d.size(); i++)
		{
			IContainerListener crafting = this.field_75149_d.get(i);
			if (this.currentItemBurnTime != tile.runTime)
			{
				crafting.func_71112_a(this, 0, tile.runTime);
			}
			if (this.burnTime != tile.tickTime || tile.tickTime == -1)
			{
				crafting.func_71112_a(this, 1, tile.tickTime);
			}
			if (this.energy != (int) tile.getEnergy())
			{
				crafting.func_71112_a(this, 2, (int) tile.getEnergy());
			}
		}
		super.func_75142_b();
	}

	@Override
	public void func_75137_b(int id, int value)
	{
		super.func_75137_b(id, value);
		if (id == 0)
		{
			this.currentItemBurnTime = value;
		} else if (id == 1)
		{
			this.burnTime = value;
		} else if (id == 2)
		{
			this.energy = value;
		}
		this.tile.runTime = this.currentItemBurnTime;
		if (this.burnTime == -1)
		{
			this.burnTime = 0;
		}
		this.tile.tickTime = this.burnTime;
		this.tile.setEnergy(this.energy);
	}

	public int getBurnTimeRemainingScaled(int scale)
	{
		if (burnTime == 0 || this.currentItemBurnTime == 0)
		{
			return 0;
		}
		return this.burnTime * scale / this.currentItemBurnTime;
	}

}
