package techreborn.items;

import me.modmuss50.jsonDestroyer.api.ITexturedItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.util.text.translation.I18n;
import net.minecraft.world.World;
import net.minecraftforge.common.DimensionManager;
import reborncore.RebornCore;
import reborncore.common.util.ChatUtils;
import techreborn.client.TechRebornCreativeTabMisc;
import techreborn.config.ConfigTechReborn;
import techreborn.lib.MessageIDs;

import java.util.List;

public class ItemFrequencyTransmitter extends ItemTextureBase implements ITexturedItem
{

	public ItemFrequencyTransmitter()
	{
		func_77655_b("techreborn.frequencyTransmitter");
		func_77637_a(TechRebornCreativeTabMisc.instance);
		func_77625_d(1);
		RebornCore.jsonDestroyer.registerObject(this);
	}

	@Override public EnumActionResult func_180614_a(ItemStack stack, EntityPlayer player, World world, BlockPos pos,
			EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ)
	{
		stack.func_77982_d(new NBTTagCompound());
		stack.func_77978_p().func_74768_a("x", pos.func_177958_n());
		stack.func_77978_p().func_74768_a("y", pos.func_177956_o());
		stack.func_77978_p().func_74768_a("z", pos.func_177952_p());
		stack.func_77978_p().func_74768_a("dim", world.field_73011_w.getDimension());

		if (!world.field_72995_K && ConfigTechReborn.FreqTransmitterChat)
		{
			ChatUtils.sendNoSpamMessages(MessageIDs.freqTransmitterID, new TextComponentString(
					TextFormatting.GRAY + I18n.func_74838_a("techreborn.message.setTo") + " X: " +
							TextFormatting.GOLD + pos.func_177958_n() +
							TextFormatting.GRAY + " Y: " +
							TextFormatting.GOLD + pos.func_177956_o() +
							TextFormatting.GRAY + " Z: " +
							TextFormatting.GOLD + pos.func_177952_p() +
							TextFormatting.GRAY + " " + I18n.func_74838_a("techreborn.message.in") + " " +
							TextFormatting.GOLD + DimensionManager.getProviderType(world.field_73011_w.getDimension())
							.func_186065_b() + " (" + world.field_73011_w.getDimension() + ")"));
		}
		return EnumActionResult.SUCCESS;
	}

	@Override public ActionResult<ItemStack> func_77659_a(ItemStack stack, World world, EntityPlayer player,
			EnumHand hand)
	{
		if (player.func_70093_af())
		{
			stack.func_77982_d(null);
			if (!world.field_72995_K && ConfigTechReborn.FreqTransmitterChat)
			{
				ChatUtils.sendNoSpamMessages(MessageIDs.freqTransmitterID, new TextComponentString(
						TextFormatting.GRAY + I18n.func_74838_a("techreborn.message.coordsHaveBeen") + " "
								+ TextFormatting.GOLD + I18n.func_74838_a("techreborn.message.cleared")));
			}
		}

		return new ActionResult<>(EnumActionResult.SUCCESS, stack);
	}

	public void func_77624_a(ItemStack stack, EntityPlayer player, List list, boolean par4)
	{
		if (ConfigTechReborn.FreqTransmitterTooltip)
		{
			if (stack.func_77978_p() != null)
			{
				int x = stack.func_77978_p().func_74762_e("x");
				int y = stack.func_77978_p().func_74762_e("y");
				int z = stack.func_77978_p().func_74762_e("z");
				int dim = stack.func_77978_p().func_74762_e("dim");

				list.add("X: " + x);
				list.add("Y: " + y);
				list.add("X: " + z);
				list.add(TextFormatting.DARK_GRAY + DimensionManager.getProviderType(dim).func_186065_b());

			} else
			{
				list.add(TextFormatting.GRAY + I18n.func_74838_a("techreborn.message.noCoordsSet"));
			}
		}
	}

	@Override public int getMaxMeta()
	{
		return 1;
	}

	@Override public String getTextureName(int arg0)
	{
		return "techreborn:items/tool/frequency_transmitter";
	}
}
