package techreborn.tiles;

import reborncore.common.IWrenchable;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.Packet;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.util.EnumFacing;
import powercrystals.minefactoryreloaded.api.IDeepStorageUnit;
import reborncore.api.IListInfoProvider;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.tile.TileMachineBase;
import reborncore.common.util.Inventory;
import reborncore.common.util.ItemUtils;
import techreborn.init.ModBlocks;

import java.util.List;

public class TileQuantumChest extends TileMachineBase
		implements IInventoryProvider, IWrenchable, IDeepStorageUnit, IListInfoProvider
{

	// Slot 0 = Input
	// Slot 1 = Output
	// Slot 2 = Fake Item

	public ItemStack storedItem;
	// TODO use long so we can have 9,223,372,036,854,775,807 items instead of
	// 2,147,483,647
	int storage = (int) Double.MAX_VALUE;
	public Inventory inventory = new Inventory(3, "TileQuantumChest", storage, this);

	@Override
	public void updateEntity()
	{
		if (!field_145850_b.field_72995_K)
		{
			if (storedItem != null)
			{
				ItemStack fakeStack = storedItem.func_77946_l();
				fakeStack.field_77994_a = 1;
				func_70299_a(2, fakeStack);
			} else if (storedItem == null && func_70301_a(1) != null)
			{
				ItemStack fakeStack = func_70301_a(1).func_77946_l();
				fakeStack.field_77994_a = 1;
				func_70299_a(2, fakeStack);
			} else
			{
				func_70299_a(2, null);
			}

			if (func_70301_a(0) != null)
			{
				if (storedItem == null)
				{
					storedItem = func_70301_a(0);
					func_70299_a(0, null);
				} else if (ItemUtils.isItemEqual(storedItem, func_70301_a(0), true, true))
				{
					if (storedItem.field_77994_a <= storage - func_70301_a(0).field_77994_a)
					{
						storedItem.field_77994_a += func_70301_a(0).field_77994_a;
						func_70298_a(0, func_70301_a(0).field_77994_a);
					}
				}
			}

			if (storedItem != null && func_70301_a(1) == null)
			{
				ItemStack itemStack = storedItem.func_77946_l();
				itemStack.field_77994_a = itemStack.func_77976_d();
				func_70299_a(1, itemStack);
				storedItem.field_77994_a -= itemStack.func_77976_d();
			} else if (ItemUtils.isItemEqual(func_70301_a(1), storedItem, true, true))
			{
				int wanted = func_70301_a(1).func_77976_d() - func_70301_a(1).field_77994_a;
				if (storedItem.field_77994_a >= wanted)
				{
					func_70298_a(1, -wanted);
					storedItem.field_77994_a -= wanted;
				} else
				{
					func_70298_a(1, -storedItem.field_77994_a);
					storedItem = null;
				}
			}
		}
	}

	@Override
	public void onDataPacket(NetworkManager net, SPacketUpdateTileEntity packet)
	{
		field_145850_b.func_147458_c(func_174877_v().func_177958_n(), func_174877_v().func_177956_o(), func_174877_v().func_177952_p(), func_174877_v().func_177958_n(),
				func_174877_v().func_177956_o(), func_174877_v().func_177952_p());
		func_145839_a(packet.func_148857_g());
	}

	@Override
	public void func_145839_a(NBTTagCompound tagCompound)
	{
		super.func_145839_a(tagCompound);
		readFromNBTWithoutCoords(tagCompound);
	}

	public void readFromNBTWithoutCoords(NBTTagCompound tagCompound)
	{

		storedItem = null;

		if (tagCompound.func_74764_b("storedStack"))
		{
			storedItem = ItemStack.func_77949_a((NBTTagCompound) tagCompound.func_74781_a("storedStack"));
		}

		if (storedItem != null)
		{
			storedItem.field_77994_a = tagCompound.func_74762_e("storedQuantity");
		}
	}

	@Override
	public NBTTagCompound func_189515_b(NBTTagCompound tagCompound)
	{
		super.func_189515_b(tagCompound);
		writeToNBTWithoutCoords(tagCompound);
		return tagCompound;
	}

	public NBTTagCompound writeToNBTWithoutCoords(NBTTagCompound tagCompound)
	{
		if (storedItem != null)
		{
			tagCompound.func_74782_a("storedStack", storedItem.func_77955_b(new NBTTagCompound()));
			tagCompound.func_74768_a("storedQuantity", storedItem.field_77994_a);
		} else{
			tagCompound.func_74768_a("storedQuantity", 0);
		}

		return tagCompound;
	}

	@Override
	public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, EnumFacing side)
	{
		return false;
	}

	@Override
	public EnumFacing getFacing()
	{
		return getFacingEnum();
	}

	@Override
	public boolean wrenchCanRemove(EntityPlayer entityPlayer)
	{
		return entityPlayer.func_70093_af();
	}

	@Override
	public float getWrenchDropRate()
	{
		return 1F;
	}

	@Override
	public ItemStack getWrenchDrop(EntityPlayer entityPlayer)
	{
		return getDropWithNBT();
	}

	public ItemStack getDropWithNBT()
	{
		NBTTagCompound tileEntity = new NBTTagCompound();
		ItemStack dropStack = new ItemStack(ModBlocks.quantumChest, 1);
		writeToNBTWithoutCoords(tileEntity);
		dropStack.func_77982_d(new NBTTagCompound());
		dropStack.func_77978_p().func_74782_a("tileEntity", tileEntity);
		return dropStack;
	}

	@Override
	public ItemStack getStoredItemType()
	{
		return this.storedItem;
	}

	@Override
	public void setStoredItemCount(int amount)
	{
		this.storedItem.field_77994_a = 0;
		this.storedItem.field_77994_a += (amount);
		this.func_70296_d();
	}

	@Override
	public void setStoredItemType(ItemStack type, int amount)
	{
		this.storedItem = type;
		this.storedItem.field_77994_a = amount;
		this.func_70296_d();
	}

	@Override
	public int getMaxStoredCount()
	{
		return this.storage;
	}

	@Override
	public void addInfo(List<String> info, boolean isRealTile)
	{
		if (isRealTile)
		{
			int size = 0;
			String name = "of nothing";
			if (storedItem != null)
			{
				name = storedItem.func_82833_r();
				size += storedItem.field_77994_a;
			}
			if (func_70301_a(1) != null)
			{
				name = func_70301_a(1).func_82833_r();
				size += func_70301_a(1).field_77994_a;
			}
			info.add(size + " " + name);
		}
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}
}
